%global install_loc %{_datadir}/eclipse/dropins/checkstyle
%global cs_ver 5.6

Summary:   Checkstyle plugin for Eclipse
Name:      eclipse-checkstyle
Version:   5.6.1
Release:   %mkrel 3
License:   LGPLv2+
Group:     Development/Java
URL:       http://eclipse-cs.sourceforge.net
BuildArch: noarch

# Source tarball generated from the below shell script
Source0: %{name}-%{version}.tar.xz
# Script to generate above tarball
Source10: eclipse-eclipsecs-fetch-src.sh

# Unpack plugins so we can symlink to system jars
Patch1:  unpack-plugins.patch

Requires: eclipse-platform
Requires: eclipse-jdt
Requires: checkstyle >= 0:%{cs_ver}
Requires: antlr-tool
Requires: guava
Requires: apache-commons-beanutils
Requires: apache-commons-collections
Requires: apache-commons-io
Requires: apache-commons-lang
Requires: apache-commons-logging
Requires: dom4j
Requires: jfreechart
Requires: jfreechart-swt

BuildRequires: java-devel
BuildRequires: jpackage-utils
BuildRequires: maven-local
BuildRequires: tycho
BuildRequires: xml-maven-plugin
BuildRequires: feclipse-maven-plugin
BuildRequires: eclipse-pde

BuildRequires: checkstyle >= 0:%{cs_ver}
BuildRequires: antlr-tool
BuildRequires: guava
BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-io
BuildRequires: apache-commons-lang
BuildRequires: apache-commons-logging
BuildRequires: dom4j
BuildRequires: jfreechart
BuildRequires: jfreechart-swt

%description
The Eclipse Checkstyle plugin integrates the Checkstyle Java code
auditor into the Eclipse IDE. The plugin provides real-time feedback
to the user about violations of rules that check for coding style and
possible error prone code constructs. 

%prep
%setup -q
%patch1

# Delete pre-built binaries
find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;
find -name '*.zip' -exec rm -f '{}' \;

# Fix checkstyle libs manifest
sed -i -e "s|checkstyle-%{cs_ver}-all.jar|checkstyle.jar,antlr.jar,guava.jar,commons-beanutils.jar,commons-collections.jar,commons-logging.jar|g" \
  net.sf.eclipsecs.checkstyle/META-INF/MANIFEST.MF net.sf.eclipsecs.checkstyle/build.properties

pushd net.sf.eclipsecs.checkstyle
ln -s $(build-classpath checkstyle) checkstyle.jar
ln -s $(build-classpath guava)      guava.jar
ln -s $(build-classpath antlr)      antlr.jar
ln -s $(build-classpath commons-beanutils)   commons-beanutils.jar
ln -s $(build-classpath commons-collections) commons-collections.jar
ln -s $(build-classpath commons-logging)     commons-logging.jar
popd

pushd net.sf.eclipsecs.core
ln -s %{_javadir}/commons-io.jar   lib/commons-io-1.2.jar
ln -s %{_javadir}/commons-lang.jar lib/commons-lang-2.3.jar
ln -s %{_javadir}/dom4j.jar        lib/dom4j-1.6.1.jar
popd

pushd net.sf.eclipsecs.ui
ln -s %{_javadir}/jcommon.jar                   lib/jcommon-1.0.16.jar
ln -s %{_javadir}/jfreechart/jfreechart.jar     lib/jfreechart-1.0.14.jar
ln -s %{_javadir}/jfreechart/jfreechart-swt.jar lib/jfreechart-1.0.14-swt.jar
popd

%build
pushd net.sf.eclipsecs.parent
mvn-rpmbuild clean package -DskipTychoVersionCheck
popd

%install
pushd net.sf.eclipsecs.parent
mvn-rpmbuild org.fedoraproject:feclipse-maven-plugin:install -DskipTychoVersionCheck \
  -DsourceRepo=../net.sf.eclipsecs-updatesite/target/site \
  -DtargetLocation=$RPM_BUILD_ROOT%{install_loc}/eclipse
popd

pushd $RPM_BUILD_ROOT%{install_loc}/eclipse/plugins/net.sf.eclipsecs.checkstyle_*
rm *.jar
ln -s $(build-classpath checkstyle) checkstyle.jar
ln -s $(build-classpath guava)      guava.jar
ln -s $(build-classpath antlr)      antlr.jar
ln -s $(build-classpath commons-beanutils)   commons-beanutils.jar
ln -s $(build-classpath commons-collections) commons-collections.jar
ln -s $(build-classpath commons-logging)     commons-logging.jar
popd

pushd $RPM_BUILD_ROOT%{install_loc}/eclipse/plugins/net.sf.eclipsecs.core_*
rm lib/*.jar
ln -s %{_javadir}/commons-io.jar   lib/commons-io-1.2.jar
ln -s %{_javadir}/commons-lang.jar lib/commons-lang-2.3.jar
ln -s %{_javadir}/dom4j.jar        lib/dom4j-1.6.1.jar
popd

pushd $RPM_BUILD_ROOT%{install_loc}/eclipse/plugins/net.sf.eclipsecs.ui_*
rm lib/*.jar
ln -s %{_javadir}/jcommon.jar                   lib/jcommon-1.0.16.jar
ln -s %{_javadir}/jfreechart/jfreechart.jar     lib/jfreechart-1.0.14.jar
ln -s %{_javadir}/jfreechart/jfreechart-swt.jar lib/jfreechart-1.0.14-swt.jar
popd

%clean
find . -type d -exec chmod u+rx {} +

%files
%doc net.sf.eclipsecs-feature/license.html
%{install_loc}



%changelog
* Thu Dec 19 2013 luigiwalser <luigiwalser> 5.6.1-3.mga4
+ Revision: 558994
- rebuild against eclipse-4.3.1-7.mga4

* Tue Oct 22 2013 umeabot <umeabot> 5.6.1-2.mga4
+ Revision: 542066
- Mageia 4 Mass Rebuild

* Mon Oct 14 2013 dmorgan <dmorgan> 5.6.1-1.mga4
+ Revision: 496848
- New version

* Sat Jan 19 2013 dmorgan <dmorgan> 5.1.0-4.mga3
+ Revision: 389600
- Rebuild against fixed eclipse

* Sat Jan 12 2013 umeabot <umeabot> 5.1.0-3.mga3
+ Revision: 351961
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 06 2012 dmorgan <dmorgan> 5.1.0-2.mga3
+ Revision: 327493
- Java Stack Mass Rebuild
- imported package eclipse-checkstyle

